{
--------------------------------------------------------------------------------
SaveIT v1.0			saves and restores settings of CabWindows within Windows95
--------------------------------------------------------------------------------
SaveIt.dpr			mainprogramm
--------------------------------------------------------------------------------
Last Changed:		29.08.1997
Autor:				Rudi Rahn
Kontakt:				soz93esw@rzaix340.rz.uni-leipzig.de
--------------------------------------------------------------------------------
Hauptprogramm, empfngt die Nachrichten der DLL ber geffnete und geschlossene
Fenster, kmmert sich um das Setzen und das Auslesen der Einstellungen.
--------------------------------------------------------------------------------
For more Information see Readme.txt
--------------------------------------------------------------------------------
}

program SaveIt;

uses
	Windows, Messages;

type
	// easy to use
   TBuf = array[0..255] of Char;

	// Important Data for Saving
	PSave = ^TSave;
   TSave = packed record
   	Titel:			TBuf;
      Position:		TRect;
      ViewStatus:		Boolean;
      ViewSymbol:		Boolean;
      Ansicht:			Byte;
      AutoArrange:	Boolean;
   end;

	// Like Data to Save, but with Next-Point for use in a list
   PCabSettings = ^TCabSettings;
   TCabSettings = packed record
   	Titel:			TBuf;
      Position:		TRect;
      ViewStatus:		Boolean;
      ViewSymbol:		Boolean;
      Ansicht:			Byte;
      AutoArrange:	Boolean;
      Next:				PCabSettings;
   end;

const
	// Some Strings
	AppName			= 'SaveIt';
   AlreadyRunning = ' luft bereits.';

   DLLName			= 'Hook.DLL';
   DLLNotFound		= ' nicht gefunden!';
   DLLHookError	= 'Shell-Hook konnte nicht installiert werden!';

	// Intervall for Retry if CabWindow is ready
   TimerIntervall = 20;

	// ClassNames
	cnCab			= 'CabinetWClass';
   cnStatus		= 'msctls_statusbar32';
   cnToolBar	= 'ToolbarWindow32';
   cnListView	= 'SysListView32';
   cnLVParent	= 'SHELLDLL_DefView';

	// ViewStyles
   vsIcon		= 0;
	vsSmallIcon	= 2;
	vsList		= 3;
	vsReport		= 1;

	// Commands to set ViewStyles (=MenuHandles, should be constant
   vsCommands:		array[0..3] of Word = ($7029, $702C, $702A, $702B);

var
	// Import from DLL
	DLLRegHlpWnd:			function(CallBackWnd: HWnd): Boolean; stdcall;
	DLLUnRegHlpWnd:		procedure(CallbackWnd: HWnd); stdcall;

	// Use in MessageLoop
	Msg:						TMsg;

	// Must register a Class
	WndClass:				TWndClass;

   // Must register a Message
	WM_NOTIFYSHELL:		Word;

   // Must load a DLL
	DLLHandle:				THandle;

	// For div. things like GetWindowText, ...
   Buf:						TBuf;

	// Handles of ChildWindows, global for easy to use
   hWndStatus:				HWnd;
   hWndToolBar:			HWnd;
   hWndListView:			HWnd;

	// the List with Settings
	FirstInList:			PCabSettings;
   Current:					PCabSettings;
   Temp:						PCabSettings;
   ToAdd:					PCabSettings;

	// for saving/loading data
   DataFile:				File of TSave;
	DataFileName:			TBuf;
   Data:						PSave;

// Reads the List with Cab-Settings
procedure ReadList;
begin
	New(FirstInList);
   with FirstInList^ do begin		// this are the initially Default-Values
      ViewStatus	:=	True;
      ViewSymbol	:=	True;
      AutoArrange	:=	True;
      Ansicht		:=	vsReport;
   end;
	{$I-}
   Assignfile(DataFile, DataFileName);
   Reset(DataFile);
   {$I+}
	if (IOResult = 0) then begin
		New(Data);
		Current := FirstInList;
		while not Eof(DataFile) do begin
			Read(DataFile, Data^);
			New(Current^.Next);
				with Current^.Next^ do begin
					Titel			:=	Data^.Titel;
					Position		:=	Data^.Position;
					ViewStatus	:=	Data^.ViewStatus;
					ViewSymbol	:=	Data^.ViewSymbol;
					Ansicht		:=	Data^.Ansicht;
					AutoArrange	:=	Data^.AutoArrange;
   	      end;
				Current := Current^.Next;
			end;
		Dispose(Data);
		CloseFile(DataFile);
	end;
end;

// Saves the List with Cab-Settings
procedure SaveList;
begin
	New(Data);
	Assignfile(DataFile, DataFileName); Rewrite(DataFile);
	Current := FirstInList;
	while (Current <> nil) do begin
		Data^.Titel			:= Current^.Titel;
		Data^.Position		:= Current^.Position;
		Data^.ViewStatus	:= Current^.ViewStatus;
		Data^.ViewSymbol	:= Current^.ViewSymbol;
		Data^.Ansicht		:= Current^.Ansicht;
		Data^.AutoArrange	:= Current^.AutoArrange;
		Write(DataFile, Data^);
  		Current := Current^.Next;
	end;
	CloseFile(DataFile);
	Dispose(Data);
end;

// Find Entry in List by Titel or returns nil
function FindByTitle(Title: TBuf): PCabSettings;
begin
	Temp := FirstInList;
	while (lstrcmpi(Title, Temp^.Titel) <> 0) and (Temp^.Next <> nil) do Temp := Temp^.Next;
	if (lstrcmpi(Title, Temp^.Titel) <> 0) then Temp := nil;
	Result := Temp;
end;

// Needed DLL not found or not propertly working
procedure DLLNotReady(NotFound: Boolean);
begin
	if NotFound then
		MessageBox(0, DLLName+DLLNotFound, AppName, MB_ICONSTOP)
   else
   	MessageBox(0, DLLHookError, AppName, MB_ICONSTOP);
	PostQuitMessage(0);
end;

// Getting Information from Window and it's Childs, writing to Current
procedure GetCabSettings(hWndCab: HWnd);
begin
	GetWindowText(hWndCab, Current^.Titel, SizeOf(Current^.Titel));
   GetWindowRect(hWndCab, Current^.Position);
   Current^.ViewStatus 	:= (GetWindowLong(hWndStatus, GWL_STYLE) = $54000100);
   Current^.ViewSymbol 	:= (GetWindowLong(hWndToolBar, GWL_STYLE) = $54000101);
  	Current^.Ansicht	 	:= (GetWindowLong(hWndListView, GWL_STYLE) mod 4);
  	Current^.AutoArrange	:= ((GetWindowLong(hWndListView, GWL_STYLE) and $300) = $300);
end;

// Gettings Handles of ChildWindows
function EnumChildProc(hWnd: HWnd; lParam: LongInt): Boolean; stdcall;
begin
 	Result:=True;
   GetClassName(hWnd, Buf, SizeOf(Buf));
   if (lstrcmpi(Buf, cnStatus) = 0)   then hWndStatus   := hWnd;
   if (lstrcmpi(Buf, cnToolBar) = 0)  then hWndToolBar  := hWnd;
   if (lstrcmpi(Buf, cnListView) = 0) then hWndListView := hWnd;
   if (lstrcmpi(Buf, cnLVParent) = 0) then EnumChildWindows(hWnd, @EnumChildProc, lParam);
end;

// Main Window Procedure
function WndProc(Wnd: HWnd; Msg, wParam: Word; lParam: LongInt): LongInt; stdcall;
begin
	case Msg of
   	WM_CREATE:
      	begin
				// Load DLL, Register Messages, GetProcAddresses
				WM_NOTIFYSHELL			:= RegisterWindowMessage('NotifySHELL');
				DLLHandle				:= LoadLibrary(DLLName);
				if (DLLHandle <> 0) then begin
					DLLRegHlpWnd   := GetProcAddress(DLLHandle, 'RegHlpWnd');
					DLLUnRegHlpWnd := GetProcAddress(DLLHandle, 'UnRegHlpWnd');
					if not DLLRegHlpWnd(Wnd) then DLLNotReady(False);
				end else DLLNotReady(True);
				lstrcpyn(DataFileName, PChar(ParamStr(0)), lstrlen(PChar(ParamStr(0)))-lstrlen(AppName)-3);
				lstrcat(DataFileName, AppName+'.dat');
				ReadList;
         end;

		WM_DESTROY, WM_QUERYENDSESSION:
      	begin
         	SaveList;
            // Free the Memory of the List
				Current := FirstInList;
            while (Current <> nil) do begin
            	Temp		:= Current^.Next;
               Dispose(Current);
               Current	:= Temp;
            end;
         	DLLUnRegHlpWnd(Wnd);
				PostQuitMessage(0);
         end;

      WM_TIMER:		// Our Window is Created
      	begin
          	hWndListView:=-1;
				// wParam is the WindowHandle -> Get Handles of Childs
				EnumChildWindows(wParam, @EnumChildProc, Wnd);
            if (hWndListView <> -1) then begin	// Window not Ready -> Wait for next TimerEvent
				   New(Current);
               GetCabSettings(wParam);
               Temp := FindByTitle(Current^.Titel);
					// set Values if different
               if (Temp <> nil ) then begin
	               if (Temp^.ViewStatus  <> Current^.ViewStatus)  then SendMessage(wParam, WM_COMMAND, $A063, 0);
   	            if (Temp^.ViewSymbol  <> Current^.ViewSymbol)  then SendMessage(wParam, WM_COMMAND, $A062, 0);
      	         if (Temp^.Ansicht     <> Current^.Ansicht)     then SendMessage(wParam, WM_COMMAND, vsCommands[Temp^.Ansicht], 0);
         	      if (Temp^.AutoArrange <> Current^.AutoArrange) then SendMessage(wParam, WM_COMMAND, $7031, 0);
            	   if (Temp <> FirstInList) then with Temp^.Position do MoveWindow(wParam, Left, Top, Right-Left, Bottom-Top, True);
               end;
					Dispose(Current);
               KillTimer(Wnd, wParam);	// Kill Timer for this Window
            end;
         end;
		else

      if (Msg=WM_NOTIFYSHELL) then	// lParam -> WindowHandle
			case wParam of 				// wParam -> Command
         	HSHELL_WINDOWCREATED:
	           	begin
                  GetClassName(lParam, Buf, SizeOf(Buf));
						// if OurClass then StartTimer with WindowHandle as ID
                  if (lstrcmpi(Buf, cnCab) = 0) then SetTimer(Wnd, lParam, TimerIntervall, nil);
               end;

            HSHELL_WINDOWDESTROYED:
            	begin
						// Save Settings
                  GetClassName(lParam, Buf, SizeOf(Buf));
                  if (lstrcmpi(Buf, cnCab) = 0) then begin
							EnumChildWindows(lParam, @EnumChildProc, Wnd);
						   New(Current);
	      	         GetCabSettings(lParam);
							Temp := FindByTitle(Current^.Titel);
               	   if (Temp <> nil) then	// -> already in List, overwrite old Values
                  		ToAdd := Temp
	                  else begin					// add new Item to List
   	               	Temp := FirstInList;
      	               while (Temp^.Next <> nil) do Temp := Temp^.Next;
         	            New(Temp^.Next);
            	         ToAdd := Temp^.Next;
               	      ToAdd.Next := nil;
							end;
					   	ToAdd^.Titel			:=	Current^.Titel;
				   	   ToAdd^.Position		:=	Current^.Position;
				      	ToAdd^.ViewStatus		:=	Current^.ViewStatus;
					      ToAdd^.ViewSymbol		:=	Current^.ViewSymbol;
					      ToAdd^.Ansicht			:=	Current^.Ansicht;
      	            ToAdd^.AutoArrange	:=	Current^.AutoArrange;
							Dispose(Current);
                  end;
               end;
         end;
	end;
	WndProc := DefWindowProc(Wnd, Msg, wParam, lParam);
end;

begin
	// only one Instance
	if (FindWindow(AppName, nil) <> 0) then begin
   	MessageBox(0, AppName+AlreadyRunning, AppName, MB_ICONINFORMATION);
   	Halt(0);
   end;

	// Register Class
	WndClass.lpfnWndProc   := @WndProc;
	WndClass.lpszClassName := AppName;
	RegisterClass(WndClass);

	// Create Window and perform MessageLoop
	if (CreateWindow(AppName, AppName, WS_OVERLAPPED, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, 0, 0, hInstance, nil) <> 0) then
		while GetMessage(Msg, 0, 0, 0) do begin TranslateMessage(Msg); DispatchMessage(Msg); end;
end.
